%global main_version 1.0
%global main_release 1

# Main package information
Name:           tee-primitives
Version:        %{main_version}
Release:        %{main_release}%{?dist}
Summary:        Trust Execution Environment (TEE) Primitives library collection

License:        BSD
URL:            http://example.com/
Source0:        https://github.com/intel/SGXDataCenterAttestationPrimitives/archive/refs/tags/DCAP_1.22.tar.gz
Source1:        LICENSE

# Global build requirements
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  pkgconfig

# Main package description
%description
The tee-primitives package provides the Trust Execution Environment (TEE) primitives software
collection for Intel(R) Software Guard Extensions (SGX), Intel(R) Trust Domain Extensions (TDX)
and other TEE technologies.

%global dcap_version 1.22
# Subpackage: libtdx-attest
%package -n libtdx-attest
Summary:	TDX-based attestation library
Version:	%{dcap_version}
Release:	1%{?dist}
ExclusiveArch:	x86_64
Requires:	tee-primitives = %{main_version}-%{main_release}%{?dist}

%description -n libtdx-attest
Intel(R) Trust Domain Extensions Attestation library

# Subpackage: libtdx-attest-devel
%package -n libtdx-attest-devel
Summary:	Development headers for libtdx-attest
Version:	%{dcap_version}
Release:	1%{?dist}
Requires:	libtdx-attest = %{dcap_version}-%{release}
ExclusiveArch:	x86_64

%description -n libtdx-attest-devel
Intel(R) Trust Domain Extensions Attestation For Developers

%prep
%autosetup -n SGXDataCenterAttestationPrimitives-DCAP_1.22
cp -p %{SOURCE1} .

%build
make -C QuoteGeneration tdx_attest %{?_smp_mflags}

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}/usr/lib64
mkdir -p %{buildroot}/usr/include/tdx
cp -a ./QuoteGeneration/quote_wrapper/tdx_attest/linux/libtdx_attest.so %{buildroot}/usr/lib64/
cp -a ./QuoteGeneration/quote_wrapper/tdx_attest/tdx_attest.h %{buildroot}/usr/include/

install -Dm0644 LICENSE %{buildroot}%{_datadir}/%{_docdir}/%{name}/LICENSE
install -Dm0644 License.txt %{buildroot}%{_datadir}/%{_docdir}/libtdx-attest/COPYING
install -Dm0644 License.txt %{buildroot}%{_datadir}/%{_docdir}/libtdx-attest-devel/COPYING

# File lists for each package

# Main package: tee-primitives (minimal)
%files
%license %{_datadir}/%{_docdir}/%{name}/LICENSE

# Subpackage: libtdx-attest
%files -n libtdx-attest
/usr/lib64/libtdx_attest.so.1
/usr/lib64/libtdx_attest.so
%license %{_datadir}/%{_docdir}/libtdx-attest/COPYING

# Development package: libtdx-attest-devel
%files -n libtdx-attest-devel
/usr/include/tdx_attest.h
%license %{_datadir}/%{_docdir}/libtdx-attest-devel/COPYING

%changelog
* Sat Jan 11 2025 Guorui Yu <Guorui.Yu@linux.alibaba.com> - 1.0-1
- init from upstream
